/*
 * Created on 2020-01-20 ( Time 17:38:35 )
 * Generated by Telosys Tools Generator ( version 3.1.2 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.salaamsolutions.projet.spasuce.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;

import javax.persistence.*;

import lombok.*;

/**
 * Persistent class for entity stored in table "critere_note_offre"
 *
* @author Back-End developper
   *
 */

@Entity
@Table(name="critere_note_offre" )
@Data // getters setters
@AllArgsConstructor // constructeur avec arguments
@NoArgsConstructor // constructeur sans arguments
public class CritereNoteOffre implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="valeur_partielle")
    private Float      valeurPartielle ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	// "offreId" (column "offre_id") is not defined by itself because used as FK in a link 
	// "critereNoteId" (column "critere_note_id") is not defined by itself because used as FK in a link 
	// "sousCritereNoteId" (column "sous_critere_note_id") is not defined by itself because used as FK in a link 
	// "moyenCalculId" (column "moyen_calcul_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="sous_critere_note_id", referencedColumnName="id")
        private SousCritereNote sousCritereNote;
    @ManyToOne
    @JoinColumn(name="offre_id", referencedColumnName="id")
        private Offre offre;
    @ManyToOne
    @JoinColumn(name="moyen_calcul_id", referencedColumnName="id")
        private MoyenCalcul moyenCalcul;
    @ManyToOne
    @JoinColumn(name="critere_note_id", referencedColumnName="id")
        private CritereNote critereNote;

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
